## ros-indigo-mcl-3dl 0.1.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(mcl_3dl)

find_package(catkin REQUIRED
  COMPONENTS
    roscpp

    pcl_ros
    tf2
    tf2_geometry_msgs
    tf2_ros
    tf2_sensor_msgs

    geometry_msgs
    mcl_3dl_msgs
    nav_msgs
    sensor_msgs
    std_msgs
    std_srvs
    visualization_msgs
)

catkin_package(
  INCLUDE_DIRS include
  CATKIN_DEPENDS
    roscpp

    pcl_ros
    tf2
    tf2_geometry_msgs
    tf2_ros
    tf2_sensor_msgs

    geometry_msgs
    mcl_3dl_msgs
    nav_msgs
    sensor_msgs
    std_msgs
    std_srvs
    visualization_msgs
)

find_package(Eigen3 REQUIRED)
find_package(PCL 1.7 REQUIRED
  COMPONENTS
    core
    filters
    kdtree
)
# Boost must be find_packaged after pcl on Ubuntu Trusty
find_package(Boost REQUIRED COMPONENTS chrono)

# Workaround for debian stretch build (https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=894656)
list(REMOVE_ITEM PCL_LIBRARIES
  "vtkGUISupportQt"
  "vtkGUISupportQtOpenGL"
  "vtkGUISupportQtSQL"
  "vtkGUISupportQtWebkit"
  "vtkViewsQt"
  "vtkRenderingQt"
)

# Workaround for the bug in PCL<1.8.1 (https://github.com/PointCloudLibrary/pcl/issues/1406)
remove_definitions(-DDISABLE_LIBUSB-1.0)

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
if(COMPILER_SUPPORTS_CXX11)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
else()
  message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
endif()

# Workaround for PCL-1.7 problem on C++11 (https://github.com/PointCloudLibrary/pcl/issues/619)
# Debug build without optimization causes Segmentation fault.
# Set default build type to Release and add -O1 to CXX_FLAGS_DEBUG.
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O1")


include_directories(${catkin_INCLUDE_DIRS} ${EIGEN3_INCLUDE_DIR} ${Boost_INCLUDE_DIRS} ${PCL_INCLUDE_DIR} include)
add_definitions(${PCL_DEFINITIONS})

# Binary installed pcl provided by Linux distro is built with -march=native
# which causes a lot of compatibility problems.
# Define PCL_NO_PRECOMPILE to disable using the binary version.
add_definitions(-DPCL_NO_PRECOMPILE)

add_executable(mcl_3dl
  src/lidar_measurement_model_beam.cpp
  src/lidar_measurement_model_likelihood.cpp
  src/mcl_3dl.cpp
)
target_link_libraries(mcl_3dl ${catkin_LIBRARIES} ${Boost_LIBRARIES} ${PCL_LIBRARIES})
add_dependencies(mcl_3dl ${catkin_EXPORTED_TARGETS})


if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)
  find_package(rosunit REQUIRED)
  add_subdirectory(test)

  find_package(roslint REQUIRED)
  roslint_cpp()
  roslint_add_test()
endif()

install(TARGETS mcl_3dl
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)
install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
)
install(DIRECTORY config/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/config
)

=== test/CMakeLists.txt ===
catkin_add_gtest(test_chunked_kdtree src/test_chunked_kdtree.cpp)
target_link_libraries(test_chunked_kdtree ${catkin_LIBRARIES} ${PCL_LIBRARIES})
catkin_add_gtest(test_filter src/test_filter.cpp)
target_link_libraries(test_filter ${catkin_LIBRARIES})
catkin_add_gtest(test_nd src/test_nd.cpp)
target_link_libraries(test_nd ${catkin_LIBRARIES})
catkin_add_gtest(test_pf src/test_pf.cpp)
target_link_libraries(test_pf ${catkin_LIBRARIES})
catkin_add_gtest(test_point_cloud_random_sampler src/test_point_cloud_random_sampler.cpp)
target_link_libraries(test_point_cloud_random_sampler ${catkin_LIBRARIES} ${PCL_LIBRARIES})
catkin_add_gtest(test_quat src/test_quat.cpp)
target_link_libraries(test_quat ${catkin_LIBRARIES})
catkin_add_gtest(test_raycast src/test_raycast.cpp)
target_link_libraries(test_raycast ${catkin_LIBRARIES} ${PCL_LIBRARIES})
catkin_add_gtest(test_vec3 src/test_vec3.cpp)
target_link_libraries(test_vec3 ${catkin_LIBRARIES})

add_executable(performance_raycast src/performance_raycast.cpp)
target_link_libraries(performance_raycast ${catkin_LIBRARIES} ${Boost_LIBRARIES} ${PCL_LIBRARIES})

add_rostest_gtest(test_expansion_resetting tests/expansion_resetting_rostest.test
    src/test_expansion_resetting.cpp)
target_link_libraries(test_expansion_resetting ${catkin_LIBRARIES})
add_dependencies(test_expansion_resetting mcl_3dl)

add_rostest_gtest(test_global_localization tests/global_localization_rostest.test
    src/test_global_localization.cpp)
target_link_libraries(test_global_localization ${catkin_LIBRARIES})
add_dependencies(test_global_localization mcl_3dl)

add_rostest_gtest(test_mcl_3dl_compat tests/mcl_3dl_compat_rostest.test
    src/test_mcl_3dl_compat.cpp)
target_link_libraries(test_mcl_3dl_compat ${catkin_LIBRARIES})

add_rostest_gtest(test_transform_failure tests/transform_rostest.test
    src/test_transform_failure.cpp)
target_link_libraries(test_transform_failure ${catkin_LIBRARIES})
add_dependencies(test_transform_failure mcl_3dl)

if(MCL_3DL_EXTRA_TESTS)

  catkin_download_test_data(
      ${PROJECT_NAME}_short_test.bag
      https://openspur.org/~atsushi.w/dataset/mcl_3dl/short_test.bag
      MD5 664ecb2824d81247ce4b26c599d99230
      FILENAME test/short_test.bag)

  catkin_download_test_data(
      ${PROJECT_NAME}_short_test_ref.topic
      https://openspur.org/~atsushi.w/dataset/mcl_3dl/short_test_ref.topic
      MD5 6ad3b72f6c50952ad1120316d4702e71
      FILENAME test/short_test_ref.topic)

  configure_file(tests/localization_rostest.test.in
      ${PROJECT_BINARY_DIR}/test/tests/localization_rostest.test)
  configure_file(tests/tf_rostest.test.in
      ${PROJECT_BINARY_DIR}/test/tests/tf_rostest.test)

  add_rostest_gtest(compare_pose ${PROJECT_BINARY_DIR}/test/tests/localization_rostest.test
      src/compare_pose.cpp)
  target_link_libraries(compare_pose ${catkin_LIBRARIES})
  add_dependencies(compare_pose 
        ${PROJECT_NAME}_short_test.bag
        ${PROJECT_NAME}_short_test_ref.topic
        mcl_3dl
      )
  add_rostest_gtest(compare_tf ${PROJECT_BINARY_DIR}/test/tests/tf_rostest.test
      src/compare_tf.cpp)
  target_link_libraries(compare_tf ${catkin_LIBRARIES})
  add_dependencies(compare_tf 
        ${PROJECT_NAME}_short_test.bag
        ${PROJECT_NAME}_short_test_ref.topic
        mcl_3dl
      )

else()

  message("To perform extra heavy tests for mcl_3dl, use -DMCL_3DL_EXTRA_TESTS:=ON")

endif()

=== debian/changelog ===
ros-indigo-mcl-3dl (0.1.4-0trusty) trusty; urgency=high

  * Fix IO figure (#212 <https://github.com/at-wat/mcl_3dl/issues/212>)
  * Fix tf timestamp (#214 <https://github.com/at-wat/mcl_3dl/issues/214>)
  * Add pf::ParticleFilter::appendParticle (#207 <https://github.com/at-wat/mcl_3dl/issues/207>)
  * Fix pointer alignment style (#210 <https://github.com/at-wat/mcl_3dl/issues/210>)
  * Migrate tf to tf2 (#208 <https://github.com/at-wat/mcl_3dl/issues/208>)
  * Fix class member naming style (#205 <https://github.com/at-wat/mcl_3dl/issues/205>)
  * Make lidar measurement model class (#195 <https://github.com/at-wat/mcl_3dl/issues/195>)
  * Add I/O diagram to the document (#199 <https://github.com/at-wat/mcl_3dl/issues/199>)
  * Update Algorithms.md (#198 <https://github.com/at-wat/mcl_3dl/issues/198>)
  * Add apt-get upgrade to test Dockerfiles (#197 <https://github.com/at-wat/mcl_3dl/issues/197>)
  * Add document for expansion resetting (#193 <https://github.com/at-wat/mcl_3dl/issues/193>)
  * Add test for expansion resetting (#192 <https://github.com/at-wat/mcl_3dl/issues/192>)
  * Add test for global localization (#188 <https://github.com/at-wat/mcl_3dl/issues/188>)
  * Refactor likelihood calculation (#189 <https://github.com/at-wat/mcl_3dl/issues/189>)
  * Add a comment to test_transform_failure (#184 <https://github.com/at-wat/mcl_3dl/issues/184>)
  * Build mcl_3dl_msgs from source on CI (#185 <https://github.com/at-wat/mcl_3dl/issues/185>)
  * Fix resampling (#183 <https://github.com/at-wat/mcl_3dl/issues/183>)
  * Fix test failure on ROS buildfarm (#181 <https://github.com/at-wat/mcl_3dl/issues/181>)
  * Fix catkin package definitions (#180 <https://github.com/at-wat/mcl_3dl/issues/180>)
  * Add tf exception handling and change message level (#177 <https://github.com/at-wat/mcl_3dl/issues/177>)
  * Relax codecov patch threshold (#179 <https://github.com/at-wat/mcl_3dl/issues/179>)
  * Allow small coverage drop (#178 <https://github.com/at-wat/mcl_3dl/issues/178>)
  * Fix test names (#176 <https://github.com/at-wat/mcl_3dl/issues/176>)
  * Add build id to CI bot comment (#174 <https://github.com/at-wat/mcl_3dl/issues/174>)
  * Fold CI bot comment (#173 <https://github.com/at-wat/mcl_3dl/issues/173>)
  * Decrease bag playback rate in integration test (#172 <https://github.com/at-wat/mcl_3dl/issues/172>)
  * Add test for NormalLikelihoodNd (#171 <https://github.com/at-wat/mcl_3dl/issues/171>)
  * Report coverage only after successful test (#170 <https://github.com/at-wat/mcl_3dl/issues/170>)
  * Add CI badges (#169 <https://github.com/at-wat/mcl_3dl/issues/169>)
  * Add codecov covarage test (#168 <https://github.com/at-wat/mcl_3dl/issues/168>)
  * Fix bot comment target slug (#167 <https://github.com/at-wat/mcl_3dl/issues/167>)
  * Contributors: Atsushi Watanabe, So Jomura

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 20 Dec 2018 00:00:00 -0000

ros-indigo-mcl-3dl (0.1.3-0trusty) trusty; urgency=high

  * Fix install of demo launch and config (#164 <https://github.com/at-wat/mcl_3dl/issues/164>)
  * Update CI and add test on ROS Melodic (#155 <https://github.com/at-wat/mcl_3dl/issues/155>)
  * Ignore gh-pr-comment failure (#162 <https://github.com/at-wat/mcl_3dl/issues/162>)
  * Compile with PCL_NO_PRECOMPILE (#161 <https://github.com/at-wat/mcl_3dl/issues/161>)
  * Fix rostest dependency (#160 <https://github.com/at-wat/mcl_3dl/issues/160>)
  * Fix roslint dependency (#159 <https://github.com/at-wat/mcl_3dl/issues/159>)
  * Update install instructions in README (#158 <https://github.com/at-wat/mcl_3dl/issues/158>)
  * Update manifest format and fix CMakeLists (#157 <https://github.com/at-wat/mcl_3dl/issues/157>)
  * Use mcl_3dl_msgs package (#152 <https://github.com/at-wat/mcl_3dl/issues/152>)
  * Test with shadow-fixed repository (#154 <https://github.com/at-wat/mcl_3dl/issues/154>)
  * Update CI bot environments (#150 <https://github.com/at-wat/mcl_3dl/issues/150>)
  * Add encrypted token for image caching (#149 <https://github.com/at-wat/mcl_3dl/issues/149>)
  * Fix migration instruction message (#147 <https://github.com/at-wat/mcl_3dl/issues/147>)
  * Fix match ratio min/max check (#146 <https://github.com/at-wat/mcl_3dl/issues/146>)
  * Add interfaces to ChunkedKdtree for external usages (#145 <https://github.com/at-wat/mcl_3dl/issues/145>)
  * Install headers (#143 <https://github.com/at-wat/mcl_3dl/issues/143>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Sat, 23 Jun 2018 00:00:00 -0000

ros-indigo-mcl-3dl (0.1.2-0trusty) trusty; urgency=high

  * Workaround for debian stretch build (#140 <https://github.com/at-wat/mcl_3dl/issues/140>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Fri, 27 Apr 2018 00:00:00 -0000

ros-indigo-mcl-3dl (0.1.1-0trusty) trusty; urgency=high

  * Update CI settings (#136 <https://github.com/at-wat/mcl_3dl/issues/136>)
  * Remove CMake warning message (#134 <https://github.com/at-wat/mcl_3dl/issues/134>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 25 Apr 2018 00:00:00 -0000

ros-indigo-mcl-3dl (0.1.0-0trusty) trusty; urgency=high

  * Migrate to ROS recommended namespace model (#130 <https://github.com/at-wat/mcl_3dl/issues/130>)
  * Minor CI setting updates (#129 <https://github.com/at-wat/mcl_3dl/issues/129>)
  * Fix package deps (#127 <https://github.com/at-wat/mcl_3dl/issues/127>)
  * Fix dockerfile style (#125 <https://github.com/at-wat/mcl_3dl/issues/125>)
  * Load CI cache from docker hub registry (#124 <https://github.com/at-wat/mcl_3dl/issues/124>)
    
      * also add build matrix
    
  * Add raycast performance benchmark (#123 <https://github.com/at-wat/mcl_3dl/issues/123>)
  * Fix GLOBAL_LOCALIZATION status (#122 <https://github.com/at-wat/mcl_3dl/issues/122>)
  * Add localization status output (#120 <https://github.com/at-wat/mcl_3dl/issues/120>)
  * Fix nodehandle usage (#121 <https://github.com/at-wat/mcl_3dl/issues/121>)


=== debian/control ===
Source: ros-indigo-mcl-3dl
Section: misc
Priority: extra
Maintainer: Atsushi Watanabe <atsushi.w@ieee.org>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, ros-indigo-catkin, ros-indigo-geometry-msgs, ros-indigo-mcl-3dl-msgs, ros-indigo-nav-msgs, ros-indigo-pcl-ros, ros-indigo-roscpp, ros-indigo-roslint, ros-indigo-rostest, ros-indigo-rosunit, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-std-srvs, ros-indigo-tf2, ros-indigo-tf2-geometry-msgs, ros-indigo-tf2-ros, ros-indigo-tf2-sensor-msgs, ros-indigo-visualization-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-mcl-3dl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-indigo-geometry-msgs, ros-indigo-mcl-3dl-msgs, ros-indigo-nav-msgs, ros-indigo-pcl-ros, ros-indigo-roscpp, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-std-srvs, ros-indigo-tf2, ros-indigo-tf2-geometry-msgs, ros-indigo-tf2-ros, ros-indigo-tf2-sensor-msgs, ros-indigo-visualization-msgs
Description: 3-D/6-DOF localization for mobile robots with 3-D LIDAR(s)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-mcl-3dl//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
